#!/usr/bin/env bash

PARTITIONS_USAGE_TO_CHECK="{{ slurm_script_healthcheck_partitions }}"
PARTITIONS_USAGE_THRESHOLD="{{ slurm_script_healthcheck_partitions_threshold }}"

MOUNTS_TO_CHECK="{{ slurm_script_healthcheck_mounts }}"

function drain() {
  REASON="$1"
  if [ "$REASON" != "" ]; then
    scontrol update NodeName=$(hostname -s) State=DRAIN Reason="$REASON"
  else
    if [ "$STATE" != "idle" ]; then
      scontrol update NodeName=$(hostname -s) State=RESUME
    fi
  fi
}

function check_partition_usage() {
  for PARTITION in $PARTITIONS_USAGE_TO_CHECK; do
    USAGE=$(df $PARTITION | sed "1d" | awk '{print $5}' | sed "s/%//")

    MES="HC($PARTITION usage);"
    REASON=$(echo "$REASON" | sed "s|$MES||")
    if [ "$USAGE" -gt "$PARTITIONS_USAGE_THRESHOLD" ]; then
      REASON="${REASON}${MES}"
    fi
  done
}

function check_mount() {
  for MOUNT in $MOUNTS_TO_CHECK; do
    MES="HC($MOUNT is empty);"
    REASON=$(echo "$REASON" | sed "s|$MES||")
    if [ -z "$( ls -A $MOUNT )" ]; then
      REASON="${REASON}${MES}"
    fi
  done
}

STATE=$(sinfo -n $(hostname -s) -eh -o "%T|%200E" | sort | uniq | awk -F "|" '{print $1}' | sed "s/\*//")
REASON=$(sinfo -n $(hostname -s) -eh -o "%T|%200E" | sort | uniq | sed "s/none//" | awk -F "|" '{print $2}' | sed 's/[ \t]*$//')

check_partition_usage

check_mount

drain "$REASON"